package com.realnet.vpspack.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.vpspack.Entity.Agent;
import com.realnet.vpspack.Services.AgentService ;






@RequestMapping(value = "/Agent")
 @CrossOrigin("*") 
@RestController
public class AgentController {
	@Autowired
	private AgentService Service;

@Value("${projectPath}")
	private String projectPath;
 






	@PostMapping("/Agent")
		  public Agent Savedata(@RequestBody Agent data) {
		Agent save = Service.Savedata(data)	;





		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Agent/{id}")
	public  Agent update(@RequestBody Agent data,@PathVariable Integer id ) {
		Agent update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Agent/getall/page")
	public Page<Agent> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Agent> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Agent")
	public List<Agent> getdetails() {
		 List<Agent> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Agent")
	public List<Agent> getallwioutsec() {
		 List<Agent> get = Service.getdetails();		
		return get;
}
@GetMapping("/Agent/{id}")
	public  Agent  getdetailsbyId(@PathVariable Integer id ) {
		Agent  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Agent/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}







}